package listeners;

import Game;

import event.EventBus;

import dialogue.DialogueManager;

import dialogue.event.LineShown;
import dialogue.event.OptionsShown;
import dialogue.event.OptionSelected;
import dialogue.event.DialogueComplete;
import dialogue.event.NextLine;

import components.DialogueBoxComponent;

class DialogueBoxController {
	public var curDialogue:DialogueBoxComponent;

	var game:Game;
	var bg:h2d.ScaleGrid;
	var tf:h2d.Text;
	var int:h2d.Interactive;
	var eventBus:EventBus;
	var parent:h2d.Object;
	var style:h2d.domkit.Style;

	public function new(eventBus:EventBus, parent:h2d.Object, style:h2d.domkit.Style) {
		this.parent = parent;
		this.style = style;
		// game = Game.current;
		// parent.getScene().add(this, 1);
		// bg = new h2d.ScaleGrid(Res.ui.toTile(), 5, 5, this);
		// bg.colorKey = 0xFF00FF;
		// tf = new h2d.Text(game.font, this);
		// tf.y = 5;
		// tf.x = 7;
		// tf.dropShadow = {
		// 	dx: 0,
		// 	dy: 1,
		// 	color: 0,
		// 	alpha: 0.3
		// };
		// int = new h2d.Interactive(0, 0, this);
		// int.onClick = function(_) click();

		eventBus.subscribe(LineShown, dialogue);
		// eventBus.subscribe(OptionsShown, renderOptions);
		// eventBus.subscribe(OptionSelected, onOptionSelected);
		eventBus.subscribe(DialogueComplete, onDialogueComplete);
	}

	// override function onRemove() {
	// 	super.onRemove();
	// 	// if (chan != null)
	// 	// 	chan.stop();
	// 	// timer.stop();
	// }

	public dynamic function onClick() {}

	public dynamic function onReady() {}

	function dialogue(event:LineShown) {
		if (curDialogue != null) {
			curDialogue.remove();
		}
		var d = new DialogueBoxComponent(event.line(), this.parent);
		style.addObject(d);

		curDialogue = d;
	}

	// function renderOptions(event:OptionsShown) {
	// 	for (option in event.options) {
	// 		addOption(option.text, option.enabled, function() {
	// 			if (option.enabled) {
	// 				globalEventBus.publishEvent(new OptionSelected(option.index));
	// 			}
	// 		});
	// 	}
	// }
  //
	// function newPanel(w, h) {
	// 	var g = new h2d.ScaleGrid(Res.ui.toTile(), 5, 5);
	// 	g.width = w;
	// 	g.height = h;
	// 	g.colorKey = 0xFF00FF;
	// 	root.scene.getH2dObject().getScene().add(g, 1);
	// 	return g;
	// }
  //
	// function addOption(o:String, enabled:Bool, callback:() -> Void) {
	// 	var spr = newPanel(Const.W, 60);
	// 	curDialogue.addChild(spr);
	// 	var tf = new h2d.Text(font, spr);
	// 	if (!enabled) {
	// 		tf.color = new Vector4(0.5, 0.5, 0.5, 1);
	// 	}
	// 	tf.text = o;
	// 	tf.x = 10;
	// 	tf.y = 10;
	// 	spr.x = 0;
	// 	spr.y = 100 + options.length * 60;
	// 	var int = new h2d.Interactive(spr.width, spr.height, spr);
	// 	int.onClick = function(_) {
	// 		callback();
	// 	}
	// 	int.cursor = Button;
	// 	options.push(spr);
	// 	return spr;
	// }
  //
	// function onOptionSelected(event:OptionSelected) {
	// 	for (o in options) {
	// 		o.remove();
	// 	}
	// 	options.splice(0, options.length);
	// }

	function onDialogueComplete(event:DialogueComplete) {
		curDialogue.remove();
	}

}
